import type { ParcelConfigObject } from 'single-spa';
import type { AppConfiguration, LifeCycles, LoadableApp, ObjectType } from '../types';
export type ParcelConfigObjectGetter = (remountContainer: HTMLElement) => ParcelConfigObject;
export default function loadApp<T extends ObjectType>(app: LoadableApp<T>, configuration?: AppConfiguration, lifeCycles?: LifeCycles<T>): Promise<ParcelConfigObjectGetter>;
